/*
 * JQuery pour genererFichier
 *
 * Auteur   : 20100
 * Date     : 30/01/2010
 * Version  : 0.0.1
 */
 $(document).ready(function(){
 
	$('.generer').each(function() {
		$(this).click(
			function(){				
				// Rcupration de l'identifiant du fichier  gnrer surlequel l'utilisateur  cliquer
				var idGenerer = $(this).attr('id');
				
				// Informe l'utilisateur que la gnration du fichier est en cours
				var stringTemp = "<p>Gnration du fichier "+idGenerer+" en cours...<p/>";
				$("#loading-content").html(stringTemp);
				$('#loading-image').removeClass('information');
				$('#loading-image').addClass('chargement');
				$("#loading").css("display","block");
				$("#loading-debug").html("");
				$("#loading-debug").css("display","none");

				// Chargement de l'iframe associ  l'idGenerer click
				var oIFrm = document.getElementById('iframePhpExcel');
				oIFrm.contentWindow.document.location = 'phpExcel_generation.php?mode='+idGenerer;
				
				// Appel de la fonction rcursive pour tester le statut aprs une attente d'une seconde.
				var timeWait = 1000;
				var timeFactor = 2;
				var timeWaitMax = 8000;
				var timeOut = 30000;
				var timeExec = 1000;
				var nbAppel = 0;					
				setTimeout(
					function() { 
						getGenerationStatus(timeWait, timeFactor, timeWaitMax, timeOut, timeExec, nbAppel, idGenerer, true); 
					}
					, timeWait
				);
			}
		);
	});

});
 

 /**
 * param (int) timeWait : Temps en ms d'attente avant de relancer une requte AJAX
 * param (int) timeFactor : Facteur pour incrmenter le temps avant le lancement rcursif
 * param (int) timeWaitMax : Temps en ms d'attente maximum avant de relancer une requte AJAX
 * param (int) timeOut : Temps en ms d'attente global maximum
 * param (int) timeExec : Temps d'execution
 * param (int) nbAppel : Nombre d'appel rcursif effectu
 * param (String) idGenerer : Type de fichier generer (PDF, MPDF, Excel5)
 * param (Bool) debug : True affiche le debug
 */
function getGenerationStatus(timeWait, timeFactor, timeWaitMax, timeOut, timeExec, nbAppel, idGenerer, debug) {		
	
	nbAppel = nbAppel+1;
	timeExec = timeExec+timeWait;
	var timeWaitCurrent = timeWait*timeFactor;
	if(timeWaitCurrent>timeWaitMax) {
		timeWaitCurrent = timeWaitMax;
	}
	
	if(timeExec<timeOut) {
		$.ajax({
			url: "phpExcel_generationStatus.php",
			type: "POST",
			success: function(data) {
				if(data=="progress") {
					var stringTemp = "<p>Gnration du fichier "+idGenerer+" en cours...<p/>";
					$("#loading-content").html(stringTemp);
					if(debug) {
						var stringTempDebug = 
						"<p class='monospace'>"+
							"--> Numro d'appel = "+nbAppel+
							"<br/> --> Temps d'attente avant le prochain appel = "+timeWaitCurrent/1000+" sec"+
							"<br/> --> Temps d'execution total = "+timeExec/1000+" sec"+
						"</p><p class='monospace'>Return statut : progress</p>";
						$("#loading-debug").append(stringTempDebug);
						$("#loading-debug").css("display","block");
					}
					setTimeout(
						function() { 
							getGenerationStatus(timeWaitCurrent, timeFactor, timeWaitMax, timeOut, timeExec, nbAppel, idGenerer, true); 
							}
						, timeWaitCurrent
					);
				} else {
					if(debug) {
						var stringTempDebug = 
						"<p class='monospace'>"+
							"--> Numro d'appel = "+nbAppel+
							"<br/> --> Temps d'execution total = "+timeExec/1000+" sec"+
						"</p><p class='monospace'>Return statut : fini</p>";
						$("#loading-debug").append(stringTempDebug);
						$("#loading-debug").css("display","block");
					}
					var stringTemp = "<p>Gnration du fichier "+idGenerer+" termin<p/>";
					$("#loading-content").html(stringTemp);
					$('#loading-image').addClass('information');
					//$("#loading").delay(3000).fadeOut("slow");
				}
			}
		});
	} else {
		if(debug) {
			var stringTempDebug = 
			"<p class='monospace'>"+
				"--> Numro d'appel = "+nbAppel+
				"<br/> --> Temps d'execution total = "+timeExec/1000+" sec"+
			"</p><p class='monospace'>TimeOut atteint</p>";
			$("#loading-debug").append(stringTempDebug);
			$("#loading-debug").css("display","block");
		}
		var stringTemp = "<p>TimeOut atteint.<p/>";
		$("#loading-content").html(stringTemp);
		$('#loading-image').addClass('information');
	}
}
